import es
import cmdlib
import cfglib
import popuplib
from configobj import ConfigObj

config = cfglib.AddonCFG(es.getAddonPath("prop") + "/settings.cfg")
propslist = ConfigObj(es.getAddonPath("prop") + "/props_list.ini")
config.text("**************************")
config.text("    Addon Settings    ")
config.text("**************************")
MAXCREDITS = config.cvar("MAXCREDITS",   15, "The max amount of credits allowed at any time")
FREECREDITS = config.cvar("FREECREDITS",   4, "The amount of credits you get when you connect")
CREDITSSPAWN = config.cvar("CREDITSSPAWN",   5, "The amount of credits gained when you spawned")
CREDITSGAIN = config.cvar("CREDITSGAIN",   1, "The amount of credits gained when you kill an enemy")
FORCECOMMAND = config.cvar("FORCECOMMAND",   '!prop', "Set the Command with that you want to open menu")

config.write()

################################Addon Infos##########################################
info = es.AddonInfo()                                                               #
info.name          = 'Propmenu'                                                     #
info.version       = '1.2 A'                                                        #
info.basename      = 'prop_mod'                                                     #
info.url           = 'http://addons.eventscripts.com/addons/view/ZMPropmenu'        #
info.author        = 'RoOF'                                                         #
es.ServerVar(info.basename, info.version, 'Propmenu').makepublic()                  #
#####################################################################################



_credits = {}


def player_activate(ev):
	addCredits(ev['userid'], int(FREECREDITS))



def player_spawn(ev):
	userid = int(ev['userid'])
	if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
		es.tell(userid,'#multi', '#lightgreen[Propmenu]Say %s to Spawn Objects !'% FORCECOMMAND)
		if userid not in _credits:
			_credits[userid] = 0
		if userid in _credits:
			if (_credits[userid] + int(CREDITSSPAWN)) < int(MAXCREDITS):
				addCredits(userid, int(CREDITSSPAWN))
				es.tell(userid, '#multi', '#green[Propmenu]#defaultYour #greenCredits:#lightgreen '+str(_credits[userid])+' (+'+str(CREDITSSPAWN)+')')
			else:
				_credits[userid] = int(MAXCREDITS)
				es.tell(userid, '#multi', '#green[Propmenu]#defaultYour #greenCredits:#lightgreen '+str(_credits[userid])+' (MAXIMAL CREDITS!)')

def player_death(ev):
	attacker = int(ev['attacker'])
	if ev['userid'] ==  attacker or ev['es_userteam'] == ev['es_attackerteam']:
		return
	if (_credits[attacker] + int(CREDITSGAIN)) < int(MAXCREDITS):
		addCredits(attacker, int(CREDITSGAIN))
		es.tell(attacker, '#multi', '#green[Propmenu]#defaultYour #greenCredits:#lightgreen '+str(_credits[attacker])+' #green(+'+str(CREDITSGAIN)+')')
	else:
		_credits[attacker] = int(MAXCREDITS)
		es.tell(attacker, '#multi', '#green[Propmenu]#defaultYour #greenCredits:#lightgreen '+str(_credits[ev['userid']])+' (MAXIMAL CREDITS!)')

def player_disconnect(ev):
	if ev['userid'] in _credits:
		del _credits[ev['userid']]


def addCredits(userid, amount):
	if userid not in _credits:
		_credits[userid] = 0
	_credits[userid] += amount

def load():
	config.execute()
	cmdlib.registerSayCommand(FORCECOMMAND, props, 'Spawn a Prop')
	for y in es.getUseridList():
		addCredits(y, 0)
		
	
def propmenu(userid):
	propMenu = popuplib.easymenu('propMenu', None, propmenu_select)
	if userid in _credits:
		propMenu.settitle("->Propmenu:\nChoose a Objekt:\nYour Current Credits: [ "+str(_credits[userid])+" ]")
	else:
		propMenu.settitle("->Propmenu:\nChoose a Objekt:\nYour Current Credits: [ 0 ]")
	for x in propslist:
		propMenu.addoption(x, x    +'   [Costs: '+str(propslist[x]['credits'])+' ]')
	propMenu.send(userid)



def unload():
	cmdlib.unregisterSayCommand(FORCECOMMAND)

def props(userid, args):
	if es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
		es.tell(userid, '#multi', '#green[Propmenu] Dead players cannot use the prop menu. ')
		return
	propmenu(userid)
        

def propmenu_select(userid, choice, popupid):
	price = int(propslist[choice]['credits'])
	if userid in _credits:
		if _credits[userid] >= price:
			_credits[userid] -= price
			es.server.insertcmd('es_prop_physics_create %s %s'%(userid, propslist[choice]['path']))
			es.tell(userid, '#multi', '#green[Propmenu]#defaultYou Spawned the Object #lightgreen'+str(choice)+' #defaultYou have #greenCredits:#lightgreen '+str(_credits[userid])+' left')
		else:
			es.tell(userid, '#multi', '#green[Propmenu]#defaultYou have not enough #greenCredits:#lightgreen '+str(_credits[userid])+' (Insufficient Funds!)')
	propmenu(userid)
